﻿@{
    ViewBag.Title = "Risk Register";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}


<link href="~/Content/plugins/fileinput/css/fileinput.css" rel="stylesheet" />

<script type="text/javascript">

    function loadDivision() {
        return $.ajax({
            url: '@Url.Action("GetDivList", "RiskRegister")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $.each(results, function (i, result) {
                    $('#ddlDivision').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlDivision').append('<option value="">No data found</option>');
            }
        });
    }
    function loadDepartment() {
        return $.ajax({
            url: '@Url.Action("GetDeptListbyDivId", "RiskRegister")?divid=' + $('#ddlDivision').val(),
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $.each(results, function (i, result) {
                    $('#ddlDepartment').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlDepartment').append('<option value="">No data found</option>');
            }
        });
    }

    $(document).ready(function () {
        loadDivision().then(loadDepartment);

        //Division
        $(document).on("change", '#ddlDivision', function (e) {
            
            loadDepartment();
        });

        $("#loader").hide();

        $(document).on('change', '.btn-file :file', function () {
            var input = $(this),
                numFiles = input.get(0).files ? input.get(0).files.length : 1,
                label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
            input.trigger('fileselect', [numFiles, label]);
        });

        $(document).ready(function () {
            $('.btn-file :file').on('fileselect', function (event, numFiles, label) {

                var input = $(this).parents('.input-group').find(':text'),
                    log = numFiles > 1 ? numFiles + ' files selected' : label;

                if (input.length) {
                    input.val(log);
                } else {
                    if (log) alert(log);
                }

            });
        });

        $("#btnDownload").click(function (evt) {
            var CheckFile = '@Url.Action("CheckTemplateFile", "RiskRegister")';
            var getUrl = '@Url.Action("GetUrl", "RiskRegister")';
            $.ajax(CheckFile, {
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                type: 'POST',
                success: function (CheckFile) {
                    if (CheckFile.success) {
                        window.location = getUrl;
                    }
                },
                error: function () {

                }
            });
        });

        $("#btnUpload").click(function (evt) {
            //Do Validation
            if ($('#file').val() == "") {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please browse Risk File, this field is mandatory", function () {
                    setTimeout(function () { $('#file').focus(); }, 500);
                });
            } else if ($('#file').size > 1048576) {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> File must be smaller than 1MB", function () {
                    setTimeout(function () { $('#file').focus(); }, 500);
                });
            } else if ($('#file').val().substring(($('#file').val().lastIndexOf('.')) + 1, $('#file').val().length) != "xls") {
                bootbox.alert("<i class='fa fa-warning fa-2x'></i> File extension is invalid, please use .xls", function () {
                    setTimeout(function () { $('#file').focus(); }, 500);
                });
            } else {
                //confirmation
                bootbox.confirm({
                    title: "<i class='fa fa-warning fa-2x'></i> Upload Confirmation",
                    message: 'Are you sure you want to upload this file. <br>If not, click Cancel',
                    buttons: {
                        'cancel': {
                            label: '<i class="fa fa-times"></i> Cancel',
                            className: 'btn-default pull-left'
                        },
                        'confirm': {
                            label: '<i class="fa fa-check"></i> Yes, Continue upload',
                            className: 'btn-primary pull-right'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            //Start upload process
                            var formData = new FormData();
                            var file = document.getElementById("file").files[0];

                            formData.append("postedFileBase", file);
                            formData.append("deptid", $('#ddlDepartment').val());

                            $.ajax({
                                type: "POST",
                                url: '@Url.Action("UploadFileADM", "RiskRegister")',
                                data: formData,
                                dataType: 'json',
                                contentType: false,
                                processData: false,
                                beforeSend: function () {
                                    $("#loader").show();
                                    $('#btnUpload').addClass('disabled');
                                    $('#btnDownload').addClass('disabled');
                                    $('#file').addClass('disabled');
                                },
                                success: function (data) {
                                    $("#loader").hide();
                                    $('#btnUpload').removeClass('disabled');
                                    $('#btnDownload').removeClass('disabled');
                                    $('#file').removeClass('disabled');
                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            location.reload(true);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });

                                }
                            });
                        }
                    }
                });
            }

        });

    });


</script>



<style>
    .label-def-margin {
        margin-top: 6px;
    }

    .required:after {
        content: "*";
        color: red;
    }
</style>

<input type="hidden" id="hdDeptId" />
<div class="col-sm-12">
    <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Upload Risk Register
        </div>
        <div class="panel-body">

            <div class="row">
                <!--Division-->
                <div class="row">
                    <div class="control-group col-md-12">
                        <div class="col-sm-2"><label class="label-def-margin" for="ddlDivision">Division</label></div>
                        <div class="col-sm-4">
                            <select class="form-control" id="ddlDivision"></select>
                        </div>
                    </div>
                </div>
                <!--Department-->
                <div class="row">
                    <div class="control-group col-md-12">
                        <div class="col-sm-2"><label class="label-def-margin" for="ddlDepartment">Department</label></div>
                        <div class="col-sm-4">
                            <select class="form-control" id="ddlDepartment"></select>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="control-group col-md-6">
                    <div class="input-group">
                        <input type="text" id="txtriskfile" placeholder="Please select risk register file" class="form-control" readonly>
                        <span class="input-group-btn">
                            <span class="btn btn-primary btn-file">
                                Browse&hellip; <input name="file" id="file" type="file" multiple>
                            </span>
                        </span>
                    </div>
                </div>
                <div class="control-group col-md-6">
                    <button class='btn btn-primary' aria-label="riskdownload" id="btnDownload"><i class="fa fa-download"></i> Download Template</button>
                    &nbsp;
                    <button class='btn btn-primary' aria-label="riskupload" id="btnUpload"><i class="fa fa-upload"></i> Upload</button>
                </div>
            </div>

            <div class="row">
                <div class="col-md-12">
                    <span id="loader"><i class="fa fa-spinner fa-spin"></i> Uploading, please wait ... </span>
                </div>
            </div>
        </div>
        <div class="panel-footer">
            <div class="row">
                <div class="col-sm-12">
                    <button type="button" class="btn btn-primary" onclick="@("window.location.href='" + @Url.Action("BackRiskRegister", "RiskRegister") + "'");">
                        <span class="glyphicon glyphicon-circle-arrow-left"></span> Back
                    </button>
                </div>
            </div>
        </div>
    </div>

</div>
